 #include "adaptivitree.h"

AdaptiviTree::AdaptiviTree(QWidget *parent, Qt::WFlags flags)
	: QMainWindow(parent, flags)
{
	dialogNew = new QDialog(this,Qt::CustomizeWindowHint);
	dialogResult = new QDialog(this,Qt::CustomizeWindowHint);
	

	ui.setupUi(this);
	newUI.setupUi(dialogNew);
	
	ui.lcdNumberTeam1->setVisible(false);
	ui.lcdNumberTeam2->setVisible(false);
	ui.labelColon->setVisible(false);
	
	comboBoxValue = 32;
	QStringList validTeamcounts;
	validTeamcounts << "4" << "8" << "16" << "32";
	newUI.comboBoxTeamCount->addItems(validTeamcounts);
	newUI.comboBoxTeamCount->setCurrentIndex(3);
	iconInput = QVector<QString>(32, "");
	teamInput.append(newUI.lineEditT1);teamInput.append(newUI.lineEditT2);teamInput.append(newUI.lineEditT3);teamInput.append(newUI.lineEditT4);
	teamInput.append(newUI.lineEditT5);teamInput.append(newUI.lineEditT6);teamInput.append(newUI.lineEditT7);teamInput.append(newUI.lineEditT8);
	teamInput.append(newUI.lineEditT9);teamInput.append(newUI.lineEditT10);teamInput.append(newUI.lineEditT11);teamInput.append(newUI.lineEditT12);
	teamInput.append(newUI.lineEditT13);teamInput.append(newUI.lineEditT14);teamInput.append(newUI.lineEditT15);teamInput.append(newUI.lineEditT16);
	teamInput.append(newUI.lineEditT17);teamInput.append(newUI.lineEditT18);teamInput.append(newUI.lineEditT19);teamInput.append(newUI.lineEditT20);
	teamInput.append(newUI.lineEditT21);teamInput.append(newUI.lineEditT22);teamInput.append(newUI.lineEditT23);teamInput.append(newUI.lineEditT24);
	teamInput.append(newUI.lineEditT25);teamInput.append(newUI.lineEditT26);teamInput.append(newUI.lineEditT27);teamInput.append(newUI.lineEditT28);
	teamInput.append(newUI.lineEditT29);teamInput.append(newUI.lineEditT30);teamInput.append(newUI.lineEditT31);teamInput.append(newUI.lineEditT32);
	
	toolButtons.append(newUI.toolButtonT1);toolButtons.append(newUI.toolButtonT2);toolButtons.append(newUI.toolButtonT3);toolButtons.append(newUI.toolButtonT4);
	toolButtons.append(newUI.toolButtonT5);toolButtons.append(newUI.toolButtonT6);toolButtons.append(newUI.toolButtonT7);toolButtons.append(newUI.toolButtonT8);
	toolButtons.append(newUI.toolButtonT9);toolButtons.append(newUI.toolButtonT10);toolButtons.append(newUI.toolButtonT11);toolButtons.append(newUI.toolButtonT12);
	toolButtons.append(newUI.toolButtonT13);toolButtons.append(newUI.toolButtonT14);toolButtons.append(newUI.toolButtonT15);toolButtons.append(newUI.toolButtonT16);
	toolButtons.append(newUI.toolButtonT17);toolButtons.append(newUI.toolButtonT18);toolButtons.append(newUI.toolButtonT19);toolButtons.append(newUI.toolButtonT20);
	toolButtons.append(newUI.toolButtonT21);toolButtons.append(newUI.toolButtonT22);toolButtons.append(newUI.toolButtonT23);toolButtons.append(newUI.toolButtonT24);
	toolButtons.append(newUI.toolButtonT25);toolButtons.append(newUI.toolButtonT26);toolButtons.append(newUI.toolButtonT27);toolButtons.append(newUI.toolButtonT28);
	toolButtons.append(newUI.toolButtonT29);toolButtons.append(newUI.toolButtonT30);toolButtons.append(newUI.toolButtonT31);toolButtons.append(newUI.toolButtonT32);
	
	iconLabels.append(newUI.labelT1);iconLabels.append(newUI.labelT2);iconLabels.append(newUI.labelT3);iconLabels.append(newUI.labelT4);iconLabels.append(newUI.labelT5);
	iconLabels.append(newUI.labelT6);iconLabels.append(newUI.labelT7);iconLabels.append(newUI.labelT8);iconLabels.append(newUI.labelT9);iconLabels.append(newUI.labelT10);
	iconLabels.append(newUI.labelT11);iconLabels.append(newUI.labelT12);iconLabels.append(newUI.labelT13);iconLabels.append(newUI.labelT14);iconLabels.append(newUI.labelT15);
	iconLabels.append(newUI.labelT16);iconLabels.append(newUI.labelT17);iconLabels.append(newUI.labelT18);iconLabels.append(newUI.labelT19);iconLabels.append(newUI.labelT20);
	iconLabels.append(newUI.labelT21);iconLabels.append(newUI.labelT22);iconLabels.append(newUI.labelT23);iconLabels.append(newUI.labelT24);iconLabels.append(newUI.labelT25);
	iconLabels.append(newUI.labelT26);iconLabels.append(newUI.labelT27);iconLabels.append(newUI.labelT28);iconLabels.append(newUI.labelT29);iconLabels.append(newUI.labelT30);
	iconLabels.append(newUI.labelT31);iconLabels.append(newUI.labelT32);

	connect(ui.actionOpen, SIGNAL(triggered()), this, SLOT(openFileDialog()));
	connect(ui.actionSave, SIGNAL(triggered()), this, SLOT(saveFileDialog()));
	connect(ui.actionNew, SIGNAL(triggered()), this, SLOT(newTournament()));
	connect(ui.horizontalSliderTime, SIGNAL(actionTriggered(int)), this, SLOT(setSliderAction(int)));
	connect(newUI.comboBoxTeamCount, SIGNAL(activated(QString)), this, SLOT(comboBoxValueChanged(QString)));

	connect(newUI.toolButtonT1, SIGNAL(clicked()), this, SLOT(iconFileDialog()));connect(newUI.toolButtonT2, SIGNAL(clicked()), this, SLOT(iconFileDialog()));
	connect(newUI.toolButtonT3, SIGNAL(clicked()), this, SLOT(iconFileDialog()));connect(newUI.toolButtonT4, SIGNAL(clicked()), this, SLOT(iconFileDialog()));
	connect(newUI.toolButtonT5, SIGNAL(clicked()), this, SLOT(iconFileDialog()));connect(newUI.toolButtonT6, SIGNAL(clicked()), this, SLOT(iconFileDialog()));
	connect(newUI.toolButtonT7, SIGNAL(clicked()), this, SLOT(iconFileDialog()));connect(newUI.toolButtonT8, SIGNAL(clicked()), this, SLOT(iconFileDialog()));
	connect(newUI.toolButtonT9, SIGNAL(clicked()), this, SLOT(iconFileDialog()));connect(newUI.toolButtonT10, SIGNAL(clicked()), this, SLOT(iconFileDialog()));
	connect(newUI.toolButtonT11, SIGNAL(clicked()), this, SLOT(iconFileDialog()));connect(newUI.toolButtonT12, SIGNAL(clicked()), this, SLOT(iconFileDialog()));
	connect(newUI.toolButtonT13, SIGNAL(clicked()), this, SLOT(iconFileDialog()));connect(newUI.toolButtonT14, SIGNAL(clicked()), this, SLOT(iconFileDialog()));
	connect(newUI.toolButtonT15, SIGNAL(clicked()), this, SLOT(iconFileDialog()));connect(newUI.toolButtonT16, SIGNAL(clicked()), this, SLOT(iconFileDialog()));
	connect(newUI.toolButtonT17, SIGNAL(clicked()), this, SLOT(iconFileDialog()));connect(newUI.toolButtonT18, SIGNAL(clicked()), this, SLOT(iconFileDialog()));
	connect(newUI.toolButtonT19, SIGNAL(clicked()), this, SLOT(iconFileDialog()));connect(newUI.toolButtonT20, SIGNAL(clicked()), this, SLOT(iconFileDialog()));
	connect(newUI.toolButtonT21, SIGNAL(clicked()), this, SLOT(iconFileDialog()));connect(newUI.toolButtonT22, SIGNAL(clicked()), this, SLOT(iconFileDialog()));
	connect(newUI.toolButtonT23, SIGNAL(clicked()), this, SLOT(iconFileDialog()));connect(newUI.toolButtonT24, SIGNAL(clicked()), this, SLOT(iconFileDialog()));
	connect(newUI.toolButtonT25, SIGNAL(clicked()), this, SLOT(iconFileDialog()));connect(newUI.toolButtonT26, SIGNAL(clicked()), this, SLOT(iconFileDialog()));
	connect(newUI.toolButtonT27, SIGNAL(clicked()), this, SLOT(iconFileDialog()));connect(newUI.toolButtonT28, SIGNAL(clicked()), this, SLOT(iconFileDialog()));
	connect(newUI.toolButtonT29, SIGNAL(clicked()), this, SLOT(iconFileDialog()));connect(newUI.toolButtonT30, SIGNAL(clicked()), this, SLOT(iconFileDialog()));
	connect(newUI.toolButtonT31, SIGNAL(clicked()), this, SLOT(iconFileDialog()));connect(newUI.toolButtonT32, SIGNAL(clicked()), this, SLOT(iconFileDialog()));


	int teamcnt = 8;
	QString title = "UEFA European Football Championship 2008";
	ui.canvas->tournament = new Tournament(teamcnt,title);
	exampleTournament();	
	QWidget::showFullScreen();
	init();
}

AdaptiviTree::~AdaptiviTree()
{
	delete dialogNew;
	delete dialogResult;
	//delete dialogWinner;
}

void AdaptiviTree::init(void)
{
	//mouseValue = 0;
	dialogWinner = new QDialog(this,Qt::CustomizeWindowHint);
	winnerUI.setupUi(dialogWinner);
	//winnerUI.buttonBox->setVisible(false);
	ui.horizontalSliderTime->setMaximum(ui.canvas->tournament->getTeamCount()-1);
	ui.horizontalSliderTime->setValue(0);
	/*if(ui.canvas->tournament->getTitle().isEmpty())
		ui.labelTitle->setVisible(false);
	else
	{
		ui.labelTitle->setVisible(true);
		
	}*/
	ui.labelTitle->setText(ui.canvas->tournament->getTitle());
	ui.canvas->round=0;
	clearDisplay();
	//QWidget::showNormal();
	ui.canvas->init();
}


void AdaptiviTree::keyPressEvent(QKeyEvent* key)
{
	bool full;
	switch(key->key())
	{
	case Qt::Key_Escape:
		QWidget::close();
		break;
	
	case Qt::Key_P:
		ui.canvas->picks = !ui.canvas->picks;
		ui.canvas->update();
		break;

	case Qt::Key_T:
		ui.toolBar->setVisible(true);
		break;
	
	case Qt::Key_Plus:
		Canvas::STEP_UP = std::max(Canvas::STEP_UP-1, -100);
		Canvas::STEP_DOWN = std::min(Canvas::STEP_DOWN+1, 100);
		break;
	
	case Qt::Key_Minus:
		Canvas::STEP_UP = std::min(Canvas::STEP_UP+1, -1);
		Canvas::STEP_DOWN = std::max(Canvas::STEP_DOWN-1, 1);
		break;

	case Qt::Key_F10:
		QWidget::showFullScreen();
		break;
	}
}

void AdaptiviTree::setSliderStep(int value)
{
	ui.horizontalSliderTime->setPageStep(value);
	ui.horizontalSliderTime->setSingleStep(value);
}

//void AdaptiviTree::getMouseValue(int value)
//{
//	if(!ui.canvas->animated)
//	{
//		if(mouseValue<value)
//			sliderAction = QAbstractSlider::SliderSingleStepAdd;
//		else
//			sliderAction = QAbstractSlider::SliderSingleStepSub;
//		
//		mouseValue = value;
//		ui.horizontalSliderTime->setValue(value);
//		setSliderStep(1);
// 		sliderValueChanged(value);
//		setSliderStep(0);
//	}
//
//}

void AdaptiviTree::setSliderAction(int action)
{	
	if(!ui.canvas->animated)
	{	
		if(action == QAbstractSlider::SliderSingleStepAdd)
		{
			ui.horizontalSliderTime->setValue(ui.horizontalSliderTime->value()+1);
			sliderAction = QAbstractSlider::SliderSingleStepAdd;
		}
		else
		{
			ui.horizontalSliderTime->setValue(ui.horizontalSliderTime->value()-1);
			sliderAction = QAbstractSlider::SliderSingleStepSub;		
		}
		
		setSliderStep(1);
		sliderValueChanged(ui.horizontalSliderTime->value());
		setSliderStep(0);
	}
}	


void AdaptiviTree::sliderValueChanged(int value)
{	
	ui.canvas->round=value;
	Game* game;

	if (value!=0)
	{
		// update display
		game = ui.canvas->tournament->getGames().at(value-1);
		updateDisplay(game);
	
		if(sliderAction != QAbstractSlider::SliderSingleStepAdd)
			game = ui.canvas->tournament->getGames().at(value);
	
		// game undecided
		if(game->getState() == Game::UNDECIDED && game->isChildGamesDecided() && sliderAction != QAbstractSlider::SliderSingleStepSub)
			editGameResult(game);
	
		// game decided (start animation)
		if(value != ui.canvas->tournament->getTeamCount()-1 && game->getState() != Game::UNDECIDED) 
		{
			int endPoint, dashOffset, color;
			Game::Bracket bracket;
			// step forward
			if(sliderAction == QAbstractSlider::SliderSingleStepAdd)
			{
				int id = game->getID();
				ui.canvas->tournament->getGameByID((id-2+id%2)/2)->setTeam(1+id%2,game->getTeam(game->getState()));
				game->getTeam(game->getState()%2+1)->setState(true);
				game->getTeam(game->getState()%2+1)->setIcon("");
			
				bracket = game->getBracket();
				dashOffset = 0;
				color = 1;
			
				if(game->getState() == Game::WINTEAM1)
				{
					ui.canvas->step = Canvas::STEP_UP;
					endPoint = bracket.y0;
				}
				else
				{
					ui.canvas->step = Canvas::STEP_DOWN;
					endPoint = bracket.y0+bracket.dy;
				}
			}
			// step backward
			else
			{	
				game->getTeam(1)->setState(false);
				game->getTeam(1)->setIcon(game->getTeam(1)->getIconFileName());
				game->getTeam(2)->setState(false);
				game->getTeam(2)->setIcon(game->getTeam(2)->getIconFileName());
			
				bracket = game->getBracket();
				dashOffset = 3*bracket.dir;
				endPoint = bracket.y0+floor((double)(bracket.dy)/2);			
			
				if(game->getState() == Game::WINTEAM1)
					ui.canvas->step = Canvas::STEP_DOWN;
				else
					ui.canvas->step = Canvas::STEP_UP;
			}
		
			ui.canvas->setAnimationEndPoint(endPoint, dashOffset, std::max(150/std::max((bracket.dy/2)/Canvas::STEP_DOWN,1),1));
			setSliderStep(0);
			ui.canvas->animatedGame = game;
			ui.canvas->animated = true;
			ui.canvas->timer->start(1);
		}
		// final game
		if(game->getID() == 0 && game->getState())
		{
			if(sliderAction == QAbstractSlider::SliderSingleStepAdd)
				displayWinner();
			else
			{
				game->getTeam(1)->setState(false);
				game->getTeam(1)->setIcon(game->getTeam(1)->getIconFileName());
				game->getTeam(2)->setState(false);
				game->getTeam(2)->setIcon(game->getTeam(2)->getIconFileName());
				ui.canvas->update();
			}
		}		
	}
	// tournament start
	else
	{
		clearDisplay();
		if(sliderAction == QAbstractSlider::SliderSingleStepSub)
		{
			game = ui.canvas->tournament->getGames()[0];
			game->getTeam(1)->setState(false);
			game->getTeam(1)->setIcon(game->getTeam(1)->getIconFileName());
			game->getTeam(2)->setState(false);
			game->getTeam(2)->setIcon(game->getTeam(2)->getIconFileName());
			
			Game::Bracket bracket = game->getBracket();
			int dashOffset = 3*bracket.dir;
			int endPoint = bracket.y0+floor((double)(bracket.dy)/2);			
			
			if(game->getState() == Game::WINTEAM1)
				ui.canvas->step = Canvas::STEP_DOWN;
			else
				ui.canvas->step = Canvas::STEP_UP;
		
			ui.canvas->setAnimationEndPoint(endPoint, dashOffset, std::max(150/std::max((bracket.dy/2)/Canvas::STEP_DOWN,1),1));
			setSliderStep(0);
			ui.canvas->animatedGame = game;
			ui.canvas->animated = true;
			ui.canvas->timer->start(1);
		}
	}
}
	

void AdaptiviTree::updateDisplay(Game* game)
{
	ui.labelTeam1->setText(game->getTeam(1)->getName());
	ui.labelLogo1->setPixmap(QPixmap(game->getTeam(1)->getIconFileName()));
	ui.lcdNumberTeam1->display(game->getResult().score[0]);
	ui.lcdNumberTeam1->setVisible(true); 


	ui.labelTeam2->setText(game->getTeam(2)->getName());
	ui.labelLogo2->setPixmap(QPixmap(game->getTeam(2)->getIconFileName()));
	ui.lcdNumberTeam2->display(game->getResult().score[1]);
	ui.lcdNumberTeam2->setVisible(true);
	ui.labelColon->setVisible(true);

}

void AdaptiviTree::clearDisplay(void)
{
	ui.labelTeam1->setText("");
	ui.labelLogo1->setPixmap(QPixmap());
	ui.lcdNumberTeam1->setVisible(false); 

	ui.labelTeam2->setText("");
	ui.labelLogo2->setPixmap(QPixmap());
	ui.lcdNumberTeam2->setVisible(false);
	ui.labelColon->setVisible(false);
}

void AdaptiviTree::editGameResult(Game* game)
{
	delete dialogResult;
	dialogResult = new QDialog(this,Qt::CustomizeWindowHint);
	resultUI.setupUi(dialogResult);
	resultUI.labelTeam1->setText(game->getTeam(1)->getName());
	resultUI.labelLogo1->setPixmap(game->getTeam(1)->getIcon());
	resultUI.spinBoxTeam1->setValue(game->getResult().score[0]);
	resultUI.labelTeam2->setText(game->getTeam(2)->getName());
	resultUI.labelLogo2->setPixmap(game->getTeam(2)->getIcon());
	resultUI.spinBoxTeam2->setValue(game->getResult().score[1]);
	
	if(dialogResult->exec() == QDialog::Accepted)
	{
		int result[] = {resultUI.spinBoxTeam1->value(),resultUI.spinBoxTeam2->value()};
		game->setResult(result);
		updateDisplay(game);
	}
}	

void AdaptiviTree::displayWinner(void)
{
	Game* game = ui.canvas->tournament->getGameByID(0);
	winnerUI.labelTeam1->setText(game->getTeam(game->getState())->getName());
	winnerUI.labelLogo1->setPixmap(game->getTeam(game->getState())->getIcon());
	game->getTeam(game->getState()%2+1)->setState(true);
	game->getTeam(game->getState()%2+1)->setIcon("");
	ui.canvas->update();
	//dialogWinner->exec();
}

void AdaptiviTree::newTournament(void)
{
	QString defaultIcon ="";//./Resources/flags/Austria.png";
	
	if(dialogNew->exec())
	{
		int teamcnt = newUI.comboBoxTeamCount->currentText().toInt();
		QString title = newUI.lineEditTitle->text();
		Tournament* t = new Tournament(teamcnt, title);
		QVector<Team*> teams;

		for (int i=0; i<teamcnt; i++)
		{	
			if(teamInput[i]->text().isEmpty())
				teams.append(new Team(i,QString("Team ").append(QString().setNum(i+1)), " ", iconInput[i]));
			else
				teams.append(new Team(i,teamInput[i]->text(), " ", iconInput[i]));
		}

		t->setTeams(teams);
		for (int i=0; i<teamcnt/2; i++)
		{	
			t->getGames()[i]->setTeams(teams[2*i], teams[2*i+1]);
		}
		
		ui.canvas->tournament = t;
		init();
	}
}

void AdaptiviTree::comboBoxValueChanged(QString value)
{
	comboBoxValue = value.toInt();
	for(int i=0; i<teamInput.size(); i++)
		if(i>=comboBoxValue)
		{
			teamInput[i]->setVisible(false);
			toolButtons[i]->setVisible(false);
			iconLabels[i]->setVisible(false);
		}
		else
		{
			teamInput[i]->setVisible(true);
			toolButtons[i]->setVisible(true);
			iconLabels[i]->setVisible(true);
		}

	dialogNew->update();
}

void AdaptiviTree::iconFileDialog(void)
{
	filename = QFileDialog::getOpenFileName(this, tr("Open Icon File"), "./", "Images (*.png *.jpg *.gif)");
	if(!filename.isEmpty())
	{
		int num = QObject::sender()->objectName().split("T").last().toInt()-1;
		iconInput.replace(num, filename);
		toolButtons.at(num)->setIcon(QIcon(QPixmap(filename)));
		iconLabels.at(num)->setPixmap(QPixmap(filename));
		teamInput.at(num)->setText(filename.split("/").last().split(".").first());
	}	
}

void AdaptiviTree::openFileDialog(void)
{
	
	filename = QFileDialog::getOpenFileName(this, tr("Open XML File"), "./", "XML files (*.xml)");
	if(!filename.isEmpty())
	{
		ui.horizontalSliderTime->setSliderPosition(0);
		ui.horizontalSliderTime->setValue(0);
		try
		{
			XmlReader reader(filename);
			Tournament* t = reader.read();
			ui.canvas->tournament = t;
		}
		catch(...)
		{
			ui.canvas->tournament = new Tournament(32, "Default Tournament");
		}
		init();
		ui.canvas->update();
	}
}

void AdaptiviTree::saveFileDialog(void)
{
	QString name = QFileDialog::getSaveFileName(this, tr("Save XML File"), "./", "XML files (*.xml)");
	
	if(!name.isEmpty())
	{
		try
		{
			XmlWriter writer(name);
			writer.write(ui.canvas->tournament);
		}
		catch(...) {}
	}
}

void AdaptiviTree::exampleTournament(void)
{
	int result[2];
	QVector<Team*> teams;	
	QString n[] = {"Portugal","Germany","Croatia","Turkey","Netherlands","Russia","Spain","Italy"};
	int r[14] = {2,3,1,3,1,3,4,2,3,2,0,3,0,1};
	
	for (int i=0; i<ui.canvas->tournament->getTeamCount(); i++)
	{	
		teams.insert(i,new Team(i,QString(n[i]),"","./Resources/flags/"+n[i]+".png"));
	}
	ui.canvas->tournament->setTeams(teams);
	for (int i=0; i<ui.canvas->tournament->getTeamCount()-1; i++)
	{	
		result[0] = r[2*i];
		result[1] = r[2*i+1];

		if(i<ui.canvas->tournament->getTeamCount()/2)
			ui.canvas->tournament->getGames()[i]->setTeams(ui.canvas->tournament->getTeams()[2*i], ui.canvas->tournament->getTeams()[2*i+1]);
		ui.canvas->tournament->getGames()[i]->setResult(result);
	}	
}
	