#ifndef PICKS_H
#define PICKS_H

#include <QVector>
#include "team.h"

class Picks
{
public:
	Picks(void);
	Picks(int numTeams);
	Picks(int numTeams, QVector<Team*> teams);
	~Picks(void);
	enum Round {SIXTEEN, EIGHT, QUARTER, HALF, FINAL};


	Round getPickForTeam(int teamId);
	bool setPickForTeam(int teamId, Round round);

private:
	QVector<Team*> teams;
	bool checkCorrectPicks(int teamId);
	void init(int numTeams);
	Round minRound;
	bool teamsKnown;
	
};

#endif